using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// <summary>
/// Tehtävä 3, vuodenajat. 
/// </summary>
public class T3_Vuodenajat
{
    /// <summary> Talvea tarkoittava merkkijono           </summary>
    public const string TALVI = "Talvi";
    /// <summary> Kevättä tarkoittava merkkijono          </summary>
    public const string KEVAT = "Kevät";
    /// <summary> Kesää tarkoittava merkkijono            </summary>
    public const string KESA = "Kesä";
    /// <summary> Syksyä tarkoittava merkkiono            </summary>
    public const string SYKSY = "Syksy";
    /// <summary> Virheellinen vuodenaika                 </summary>
    public const string VIRHE = "";

    public static void Main()
    {
        Console.WriteLine(VuodenaikaIf(1));
        Console.WriteLine(VuodenaikaSwitch(12));

        Console.WriteLine("Vuodenajat:");
        for (int i = 0; i <= 13; i++)
        {
            Console.WriteLine("{0,2} {1}", i, VuodenaikaTaulukko(i));
        }

    }

    public static string VuodenaikaTaulukko(int kuukausi)
    {
        string[] kuukaudet =
        {
            TALVI, TALVI,
            KEVAT, KEVAT, KEVAT,
            KESA, KESA, KESA,
            SYKSY, SYKSY, SYKSY,
            TALVI
        };

        if (kuukausi < 1 || kuukausi > 12) return VIRHE;
        return kuukaudet[kuukausi - 1];
    }

    public static string VuodenaikaIf(int kuukausi)
    {
        if (kuukausi < 1) return VIRHE;
        if (kuukausi > 12) return VIRHE;
        if (kuukausi < 3) return TALVI; // 1, 2
        if (kuukausi < 6) return KEVAT; // 3, 4, 5
        if (kuukausi < 9) return KESA; // 6, 7, 8
        if (kuukausi < 12) return SYKSY; // 9, 10, 11
        else return TALVI; // 12
    }

    /// <summary>
    /// Tämä versio käyttää C#:n uutta switch expression -ominaisuutta 
    /// </summary>
    /// <param name="kuukausi"></param>
    /// <returns></returns>
    public static string VuodenaikaSwitchUusi(int kuukausi)
    {
        return kuukausi switch
        {
            12 or 1 or 2 => TALVI,
            3 or 4 or 5 => KEVAT,
            6 or 7 or 8 => KESA,
            9 or 10 or 11 => SYKSY,
            _ => VIRHE,
        };
    }

    public static string VuodenaikaSwitch(int kuukausi)
    {
        switch (kuukausi)
        {
            case 12:
            case 1:
            case 2: return TALVI;
            case 3:
            case 4:
            case 5: return KEVAT;
            case 6:
            case 7:
            case 8: return KESA;
            case 9:
            case 10:
            case 11: return SYKSY;
            default: return VIRHE;
        }
    }


/// <summary>
/// LISÄTIETOA KIINNOSTUNEILLE: Vuodenaika luokilla. Tehdään Kuukausi-luokka ja hyödynnetään sitä. 
/// </summary>
/// <param name="kuukausi">Kuukauden numero</param>
/// <returns></returns>
public static Vuodenaika VuodenaikaLuokilla(int kuukausi)
    {
        // Jos kuukausi ja vuodenaika haluttaisiin liittää toisiinsa,
        // voitaisiin muodostaa luokka (class) tai tietue (struct),
        // jossa kukin kuukausi sisältää tiedon paitsi omasta nimestään
        // myös omasta vuodenajastaan. Vuodenaika ilmaistaan käyttämällä 
        // nk. lueteltua tyyppiä, eli enum-tyyppistä luokkaa. 
        

        Kuukausi[] kuukaudetS =
        {
           new Kuukausi { Nimi = "Tammikuu", Vuodenaika = Vuodenaika.Talvi},
           new Kuukausi { Nimi = "Helmikuu", Vuodenaika = Vuodenaika.Talvi},
           new Kuukausi { Nimi = "Maaliskuu", Vuodenaika = Vuodenaika.Kevät} // ... ja niin edelleen. 
        };

        // Vielä yksi vaihtoehto olisi tehdä sanakirja (Dictionary),
        // jossa avaimena on kuukauden numero ja arvona Kuukausi-olio.
        // Tällöin voitaisiin palauttaa suoraan parametrina saatua lukua
        // vastaava kuukausi ilman vähennyslaskua.
        Dictionary<int, Kuukausi> kuukaudetD = new Dictionary<int, Kuukausi>()
        {
             { 1, new Kuukausi { Nimi = "Tammikuu", Vuodenaika = Vuodenaika.Talvi} },
             { 2, new Kuukausi { Nimi = "Helmikuu", Vuodenaika = Vuodenaika.Talvi} },
             { 3, new Kuukausi { Nimi = "Maaliskuu", Vuodenaika = Vuodenaika.Kevät} }
        };

        return kuukaudetS[kuukausi - 1].Vuodenaika;
        
        // Dictionary-totetukseen liittyen: 
        // Jos annetaan väärä kuukausi (<1 tai >12) niin voidaan palauttaa "olematon" vuodenaika
        // Vuodenaika-enumeraatiosta.
        // if (!kuukaudetD.ContainsKey(kuukausi)) return Vuodenaika.None;
        // Muussa tapauksessa palautetaan arvo
        // return kuukaudetD[kuukausi].Vuodenaika; 
        
    }
}

/// <summary>
/// Vuodenaika. Määritellään Vuodenaika-tyypille neljä vakioarvoa: Talvi, Kevät, Kesä, Syksy.
/// None-arvo viittaa "olemattomaan" vuodenaikaan, joka toimii poikkeuksellisia tilanteita varten,
/// ks. toteutus ylempänä.  
/// </summary>
public enum Vuodenaika
{
    None, Talvi, Kevät, Kesä, Syksy
}

/// <summary>
/// Kuukausi
/// </summary>
public class Kuukausi
{
    /// <summary>
    /// Kuukauden nimi
    /// </summary>
    public string Nimi;
    
    /// <summary>
    /// Kuukauden vuodenaika.
    /// </summary>
    public Vuodenaika Vuodenaika;
}